clear all
global m ro sigth sige n k A Sigmas SigthM zbarvM Omega SO
%store the different values of rho and sigmaepsilon
tic
net = 50;
   

r = 1 ;        

%definition of containers to collect data for transaction level dataset
profvec=[];   %profit
volvec=[];    %volume
pricevolvec=[]; %price-volatility 
baspvec=[]; %average spread 
degown=[];  %degree of one counterparty
degother=[]; %degree of other counterparty
prestown=[]; %eigenvalue centrality of one counterparty
prestother=[]; %eigenvalue centrality of other counterparty
densvec=[]; %density of network 
diavec=[]; % diameter 
sigevec=[]; % information precision ratio 
asymmvec=[];%standard deviation of degree distribution 

%definition of containers to collect data for dealer-level dataset

sumprofdm=[]; % total profit per dealer
asymmdm=[];  % standard deviation of degree distribution
baspdm=[];   % average cost of transaction per dealer
grossvoldm=[];% gross volume
prdispdm=[]; %price dispersion
prvoldm=[]; % price volatility
intmeddm=[];% intermediation
degdm=[]; %degree
prestdm=[];% eigenvalue centrality
diadm=[]; %diameter
densdm=[]; %density
diffydm=[]; % overweighting of private information
sigedm=[]; %information precision ratio

%network level containers does not have to be assigned in advance, but
%just for completeness they are as follows

%dispnt - dispersion 
%densnt - density 
%asymnt - standard deviation
%diant - diameter
%signt - information precision ratio
%adjmat - adjacency matrix


%% parameters remaining constant for every network
m=-10; % \beta_ij
n=54;
ro=0.5;
sigth=1   ; %sigma_thetha
 sige=1;

%% possible adjacency matrices 
A1=ones(n)-diag(ones(n,1)); % completce network
k=2; %parameter for circulantinterm
A2=cirgenfun(n,k); % (n,k) circulants
A3=[0 ones(1,n-1);
      repmat([1 zeros(1,n-1)],n-1,1)]; %n-star

A4=A2;
A4(1,n)=0;
A4(n,1)=0; % line

%%simulating a dataset of length(S) rounds of trading, each with a different
%network where the vector S picks the types of networks. 
% for example:
% S=1:5 generates 5 networks (complete, circle, star, line, a random)
% S=5:5 generates a single random network
% S=5:104 generates 100 random networks

%% possible adjacency matrices 

load('jrdat4plow','rmat')
sizeofsample=(length(rmat)+1)/length(unique(rmat));
SR=1;
while r<net*length(unique(rmat))+1    
start=reshape(rand(n),n^2,1); 
      
load('jrdat4plow','A8')
A7=A8;
clear A8;
A=A7(:,:,SR);
%G=graph(A);
clear A7
n=length(A); 
%sige=(1+0.1*randn).^2; %picking a random sigma_epsilon
sige=1;
    
    %sigthm(rv);
  Sigmas=diag((sigth+sige).*ones(n,1)); % Sigma matrix
    Sigmas(Sigmas==0)=ro.*sigth;
    
SigthM=diag(sigth.*ones(n,1)); 
    SigthM(SigthM==0)=ro.*sigth; 

    Sigthis=[sigth ro*sigth*ones(1,n-1)];
  Omega=diag(sigth*(1-ro)/(sigth+sige-ro*sigth)*(1+ro*sige/((1-ro)*(sigth+sige-ro*sigth+n*ro*sigth)))*ones(n,1));
    Omega(Omega==0)=sigth*(1-ro)/(sigth+sige-ro*sigth)*ro*sige/((1-ro)*(sigth+sige-ro*sigth+n*ro*sigth));
SO=Sigmas*Omega;
  %% finding the equilibrium of the guessing game
    [vbar,fval2,exitflag,output] = fsolve(@vbarfun2,start);
    fval2;
    vbarM2=reshape(vbar,n,n); 
    V=vbarM2'; % V matrix
    
    zbarM2=zbarfun2(vbarM2); 
    Zbar=zbarM2'; %Zbar matrix
    yvecM2=yfuna(vbarM2);
    Ybar=diag(yvecM2); %Ybar matrix 
  %% OTC game

    zbarvM=zbarM2;
    [zMv,fvalzM,exitflag,output] = fsolve(@zMfun2,reshape(zbarvM,n^2,1));
    zM2=reshape(zMv,n,n);
    Z=zM2'; % Z matrix
   
    
    while min(min(zM2))<0||max(max(zM2))>2
           SR=SR+1;
    load('jrdat4plow','A8')
    A7=A8;
clear A8;

A=A7(:,:,SR);

clear A7
    [vbar,fval1,flag1,output1] = fsolve(@vbarfun2,start);
 
    vbarM2=reshape(vbar,n,n); 
    V=vbarM2'; % V matrix
    
    zbarM2=zbarfun2(vbarM2); 
    Zbar=zbarM2'; %Zbar matrix
    yvecM2=yfuna(vbarM2);
    Ybar=diag(yvecM2); %Ybar matrix
    zbarvM=zbarM2;
    [zMv,fvalzM,exitflag,output] = fsolve(@zMfun2,reshape(zbarvM,n^2,1));
    zM2=reshape(zMv,n,n);
    
    end
    G=graph(A);
  
     %% planner's solution

       input1=reshape(zbarM2,n^2,1);
    input2=input1(input1~=0);
    inputsoc=[yvecM2';input2];
    options=optimset('MaxFunEvals',1000*length(inputsoc),'MaxIter',1000,'LargeScale','off','TolFun',1e-4);
[zbarstr,fval1,exitflagStr,output] = fminunc(@sumexpfuntrace,inputsoc,options);
     yvecS=zbarstr(1:n)';
     eflagS(r)=exitflagStr;
%% informational efficiency    
 input3=zbarstr(n+1:end);
 zbarS=refillZ(input3);
   WS=inv(eye(n)-zbarS);
  VS=diag(yvecS)*WS;    
  diffeff(r)=trace(vbarM2*(vbarM2'-2*Omega)*Sigmas)-trace(VS*(VS'-2*Omega)*Sigmas);
  nums(r)=trace(Omega'*Omega*Sigmas)+sige*(sige/sigth+(n-2)*ro-(n-1)*ro^2+1)/((sige/sigth-ro+1)*(sige/sigth+(n-1)*ro+1));
  diffeff2(r)=(trace(vbarM2*(vbarM2'-2*Omega)*Sigmas)-trace(VS*(VS'-2*Omega)*Sigmas))/nums(r);
     diffy=(yvecM2'-yvecS')./yvecS'; % vector of percentage overweighting of private signal
     
%% profit and volume 
profmat=A;
volmat=A;
pricevolmat=A;

   for i3=1:n 
    z1=zM2(:,i3); %z_ij
   z2=zM2(i3,:)'; %z_ji
cplusbeta1v=A(i3,:)'.*m.*(((2-z2)./(z1+z2-z1.*z2)));
%trading intensity of row to col 

expcoef=vbarM2(:,i3);
ind=find(A(i3,:)>0);
profM1link=zeros(numel(ind),1);
clear sigmaqM1link qM1linkcoef pricevol pcoef
for ind2=1:numel(ind);
ind3=ind(ind2);    
expcoefother=vbarM2(:,ind3);
pM1coef1=((z2(ind3)-2)*expcoef+(z1(ind3)-2)*expcoefother)/(z2(ind3).*z1(ind3)-4); % coefficients of signals in price between i3 and ind2
expminusp=expcoef-pM1coef1;
profM1link(ind2)=-cplusbeta1v(ind3)*expminusp'*(SigthM(:,i3)-Sigmas*pM1coef1);

profM1link(isnan(profM1link))=0;
sigmaqM1link(ind2)=((cplusbeta1v(ind3))^2)*(expminusp'*Sigmas*expminusp);
pcoef(ind2,:)=pM1coef1;
pricevol(ind2)=pM1coef1'*Sigmas*pM1coef1;
sigmaqM1link(isnan(sigmaqM1link))=0;
qM1linkcoef(:,ind2)=-cplusbeta1v(ind3)*expminusp; %coefficients of signals in quantity from i3 to ind2
qM1linkcoef(isnan(qM1linkcoef))=0;
expminuspM(:,ind2,i3)=expminusp;
end
profmat(i3,ind)=profM1link; % 1,2 shows profit for 1 on trade from 1 to 2
tradeint(i3,ind)=-cplusbeta1v(ind);
volmat(i3,ind)=sqrt(sigmaqM1link); % 1,2 shows volume of 1 to 2
 netqcoef=sum(qM1linkcoef,2);
netvol(i3)=sqrt(netqcoef'*Sigmas*netqcoef);

%prdisp(i3,1)=det(pcoef*Sigmas*pcoef');
pricevolmat(i3,ind)=pricevol;
pricevoldm1(i3,1)=mean(pricevol);
   end
   

sumprof=sum(profmat,2);
grossvol=sum(volmat,2);
intmed=netvol'./grossvol;
[e,v]=eigs(A);
prest=abs(e(:,1));

deg=sum(A,2);
degothers=(A*deg)./(deg);


   z1=zM2'; %z_ij
z2=zM2;  
   cplusbetaji=A.*m.*((2-z2)./(z1+z2-z1.*z2));
cplusbetaij=A.*m.*((2-z1)./(z1+z2-z1.*z2));
  cmat=cplusbetaij+m;
basp=-2./cmat;
slopemat=-1./cplusbetaij;
slopedmv=nanmean(slopemat,2);
baspdmv=nanmean(basp,2);
slopedmv2=nanmean(slopemat,1)';
tmat=-cplusbetaij;
illiq=1./tmat;
tdmv=nanmean(-cplusbetaij,1)';
illiq1=nanmean(illiq,1)';
illiq2=nanmean(illiq,2);

cplusbetaji(isnan(cplusbetaji))=0;
cplusbetaij(isnan(cplusbetaij))=0;

basp(isnan(basp))=0;
%% network level

  ; %dispersion
CovM=covprice(zM2,vbarM2);
stst=sqrt(diag(CovM)*diag(CovM)');
CorrM=CovM./stst;
disp3=det(CorrM);
disp4M2=min(min(CorrM)); %measure of dispersion is minimal correlation between two prices
disp3M2=mean(mean(CorrM)); %measure of dispersion is mean correlation between two prices  
  
dens=sum(sum(A))/n;  
dia=diameter(A);
asymm=std(sum(A));
% %% buliding the dataset
% %transactionlevel data
% baspvec=[baspvec;reshape(basp,n^2,1)];
% profvec=[profvec;reshape(profmat,n^2,1)];
% volvec=[volvec;reshape(volmat,n^2,1)];
% pricevolvec=[pricevolvec;reshape(pricevolmat,n^2,1)];
% degown=[degown;repmat(deg,n,1)];
% degother=[degother;reshape(repmat(deg',n,1),n^2,1)];
% prestown=[prestown;repmat(prest,n,1)];
% prestother=[prestother;reshape(repmat(prest',n,1),n^2,1)];
% densvec=[densvec;dens*ones(n^2,1)];
% diavec=[diavec;dia*ones(n^2,1)];
% sigevec=[sigevec;sige*ones(n^2,1)];
% asymmvec=[asymmvec;asymm*ones(n^2,1)];    
% ind0=find(baspvec~=0);
% baspvec=baspvec(ind0);
% volvec=volvec(ind0);
% pricevolvec=pricevolvec(ind0);
% profvec=profvec(ind0);
% degown=degown(ind0);
% degother=degother(ind0);
% prestown=prestown(ind0);
% prestother=prestother(ind0);
% densvec=densvec(ind0);
% 
% diavec=diavec(ind0);
% sigevec=sigevec(ind0);
% asymmvec=asymmvec(ind0);
% %% dealer level dataset
% baspdm=[baspdm;baspdmv];
% %prdispdm=[prdispdm;prdisp];
% prvoldm=[prvoldm;pricevoldm1];
% sumprofdm=[sumprofdm;sumprof];
% grossvoldm=[grossvoldm;grossvol];
% intmeddm=[intmeddm;intmed];
% degdm=[degdm;deg];
% 
% prestdm=[prestdm;prest];
% diadm=[diadm;dia*ones(n,1)];
% densdm=[densdm;dens*ones(n,1)];
% diffydm=[diffydm;diffy];
% sigedm=[sigedm;sige*ones(n,1)];
% asymmdm=[asymmdm;asymm*ones(n,1)];
%% network level dataset

sigmevec(r)=ro;
nnumnt(r)=SR;
  densnt(r)=dens; 


signt(r)=ro;
%adjmat(1:n,1:n,nnum)=A;

%% new
asymnt(r)=asymm;
dispnt(r)=disp4M2;
disp3m(r)=disp3;
diant(r)=dia;
mindiffy(r)=min(diffy);
ass(r)=assortativity(A,0);


%%

clust_vec(r)=clust_coeff(A);
learn_vec(r)=mean(condvarfun(vbarM2));
asymnt_vec(r) = asymm;

dispnt_vec(r)=disp4M2;
dispnt_vec2(r)=disp3M2;
diant_vec(r)=dia;
gini_vec(r)=ginicoeff(grossvol);
degcorr(r)=corr(deg,degothers);

% x=regress(1./baspvec,[ones(size(degown+degother)) degown+degother])';
% betacostdpd_vec(r)=x(2);

mindist(r)=min(diffy);
x=regress(diffy, [ones(size(deg)) deg])';
betay_vec2(r)=x(2);
betay_c(r)=x(1);
corry(r)=corr(deg,diffy);
x=regress(sumprof, [ones(size(deg)) deg])';
betaprof_vec2(r)=x(2);
betaprof_c(r)=x(1);
corrprof(r)=corr(deg,sumprof);
x=regress(1./intmed,[ones(size(deg)) deg])';
betaint_vec2(r)=x(2);
betaint_c(r)=x(1);
corrint(r)=corr(deg,1./intmed);
x=regress(grossvol,[ones(size(deg)) deg])';
betavol_vec2(r,1)=x(2);
betavol_c(r)=x(1);
corrvol(r)=corr(deg,grossvol);
x=regress(baspdmv,[ones(size(deg)) deg])';
betacostd_vec2(r)=x(2);
betacostd_c(r)=x(1);
corrbasp(r)=corr(deg,baspdmv);
x=regress(tdmv,[ones(size(deg)) deg])';
betat_vec(r)=x(2);
betat_c(r)=x(1);
x=regress(condvarfun(vbarM2)',[ones(size(deg)) deg])';
betalearn_vec(r)=x(2);
betalearn_c(r)=x(1);
corrcondvar(r)=corr(deg,condvarfun(vbarM2)');
x=regress(slopedmv,[ones(size(deg)) deg])';
betas_vec(r)=x(2);
betas_c(r)=x(1);

x=regress(illiq1,[ones(size(deg)) deg])';
betailliq1_vec(r)=x(2);
x=regress(illiq2,[ones(size(deg)) deg])';
betailliq2_vec(r)=x(2);

x=regress(degothers,[ones(size(deg)) deg])';
betdeg_vec(r)=x(2);


x=regress(slopedmv2,[ones(size(deg)) deg])';
betas2_vec(r)=x(2);
betas2_c(r)=x(1);
rvec(r)=rmat(SR);


   exper=floor((r-1)/net)+1;
if r==net*exper;
      SR=sizeofsample*exper;

    
else
    SR=SR+1;
end

 
 r = r + 1
 SR
    end
      
    save datab_r8plow.mat

    %%


