clear all
global ro sigth sige n A  SigmaS M N nc np Nvec Sigmas SigthM V SigmasS
%%
betp=-1;
%m0=betp; 

sigth=0.1;

%ro=0.9
sige=1;

rom=[0.01:0.01:0.99];
%rom=0.5;
maxN=21; % a multiple of four
for nu=1:length(rom);
ro=rom(nu)



%% 9 star
  n=9;
sig=sige./sigth;
v11=(1-ro)/(1+sig-ro)*(1+(ro*sig)/((1-ro)*(1+sig+(n-1)*ro)));
v1j=(1-ro)/(1+sig-ro)*((ro*sig)/((1-ro)*(1+sig+(n-1)*ro)));
ve=((1-ro)*(1+(n-1)*ro)+sig*(1+(n-1)*ro^2))/((1+sig-ro)*(1+sig+(n-1)*ro));
vte=ro*((1-ro)*(1+(n-1)*ro)+sig*(2+(n-2)*ro))/((1+sig-ro)*(1+sig+(n-1)*ro));
vi1=(vte*(1+sig)-ro)/((ve*(1+sig)-ro^2))*v11;
vii=(ve-vte*ro)/(ve*(1+sig)-ro^2)+(vte*(1+sig)-ro)/((ve*(1+sig)-ro^2))*v1j;
vij=(vte*(1+sig)-ro)/((ve*(1+sig)-ro^2))*v1j;
yp=(ve-vte*ro)/(ve*(1+sig)-ro^2);
zp=(vte*(1+sig)-ro)/((ve*(1+sig)-ro^2));
zc=v1j./(yp+(n-1)*zp*v1j);
yc=v11*yp./(yp+(n-1)*zp*v1j);

zpM(nu)=2*zp;
zcM(nu)=zc*(n-1-(n-2)*zp)+1-sqrt((zc*(n*(1-zp)+2*zp-1)+1).^2-4*zc);
ypM=yp*(1-zpM(nu)*(2-zcM(nu))/(4-zpM(nu)*zcM(nu)));
ycM=yc*(1-(n-1)*zcM(nu)*(2-zpM(nu))/(4-zpM(nu)*zcM(nu)));
%tp=-bet.*(2-zcM)./(zpM+zcM-zpM.*zcM);
%tc=-bet.*(2-zpM)./(zpM+zcM-zpM.*zcM);
betS=n*betp./(n-1)

wc=(2-zpM(nu))/(4-zpM(nu)*zcM(nu));
wp=(2-zcM(nu))/(4-zpM(nu)*zcM(nu));
%check1=zp-zpM*(2-zpM)/(4-zcM*zpM)/(1-zpM*(2-zcM)/(4-zpM*zcM));
%check2=zc-zcM*(2-zcM)/(4-zcM*zpM)/(1-(n-1)*zcM*(2-zpM)/(4-zpM*zcM));
tstarp(nu)=-betS.*(2-zcM(nu))./(zcM(nu)+zpM(nu)-zcM(nu).*zpM(nu));
tstarc(nu)=-betS.*(2-zpM(nu))./(zcM(nu)+zpM(nu)-zcM(nu).*zpM(nu));
cSM(nu)=betS.*(zpM(nu)-2).*(zcM(nu)-1)./(zcM(nu)+zpM(nu)-zcM(nu).*zpM(nu));
cSP(nu)=betS.*(zcM(nu)-2).*(zpM(nu)-1)./(zcM(nu)+zpM(nu)-zcM(nu).*zpM(nu));

Zan=[0 zpM(nu) 0;
    zcM(nu) 0 zcM(nu);
    0 zpM(nu) 0];
Zanbar=[0 zp 0;
    zc 0 zc;
    0 zp 0];
Van=[vii vi1 vij;
    v1j v11 v1j;
    vij vi1 vii];
Yan=diag([ypM ycM ypM]);
eM=[v11 repmat(v1j,1,n-1)];
eP=[vi1 vii repmat(vij,1,n-2)];
Sigmas=diag((sigth+sige).*ones(n,1)); % Sigma matrix
Sigmas(Sigmas==0)=ro.*sigth;
vareM(nu)=eM*Sigmas*eM';
vareP(nu)=eP*Sigmas*eP';
covMP(nu)=eM*Sigmas*eP';
yCS1(nu)=v11;
vCS2(nu)=v1j;

pvarnetS(nu)=-(n-1).*betS./2.*((cSM(nu)+betS).^2.*vareP(nu)+(cSP(nu)+betS).^2.*vareM(nu)+2.*(cSM(nu)+betS).*(cSP(nu)+betS).*covMP(nu))./((cSM(nu)+cSP(nu)+3.*betS).^2);
covnetSP(nu)=-(cSM(nu)+betS).*(n-1).*((cSP(nu)+2.*betS).^2.*vareP(nu)+(cSP(nu)+betS).^2.*vareM(nu)-2.*(cSP(nu)+betS).*(cSP(nu)+2.*betS).*covMP(nu))./((cSM(nu)+cSP(nu)+3.*betS).^2);
covnetSM(nu)=-(n-1).*(cSP(nu)+betS).*((cSM(nu)+2.*betS).^2.*vareM(nu)+(cSM(nu)+betS).^2.*vareP(nu)-2.*(cSM(nu)+betS).*(cSM(nu)+2.*betS).*covMP(nu))./((cSM(nu)+cSP(nu)+3.*betS).^2);

 

volumSP(nu)=abs(cSM(nu)+betS).*sqrt((cSP(nu)+2.*betS).^2.*vareP(nu)+(cSP(nu)+betS).^2.*vareM(nu)-2.*(cSP(nu)+betS).*(cSP(nu)+2.*betS).*covMP(nu))./sqrt((cSM(nu)+cSP(nu)+3.*betS).^2);
volumSM(nu)=(n-1).*abs(cSP(nu)+betS).*sqrt((cSM(nu)+2.*betS).^2.*vareM(nu)+(cSM(nu)+betS).^2.*vareP(nu)-2.*(cSM(nu)+betS).*(cSM(nu)+2.*betS).*covMP(nu))./sqrt((cSM(nu)+cSP(nu)+3.*betS).^2);
covpartSP(nu)=-(cSM(nu)+betS).*(n-1).*((cSP(nu)+2.*betS).*vareP(nu)-(cSP(nu)+betS).*covMP(nu))./((cSM(nu)+cSP(nu)+3.*betS));
covpartSM(nu)=-(n-1).*(cSP(nu)+betS).*((cSM(nu)+2.*betS).*vareM(nu)-(cSM(nu)+betS).*covMP(nu))./((cSM(nu)+cSP(nu)+3.*betS));
totwelfS(nu)=pvarnetS(nu)+covnetSM(nu)+covnetSP(nu);

% conditional variance of theta given all the signalswith all the information
Sigmas=diag((sigth+sige).*ones(n,1));
    Sigmas(Sigmas==0)=ro.*sigth;
    
SigthM=diag(sigth.*ones(n,1));
    SigthM(SigthM==0)=ro.*sigth;

minvar=SigthM-SigthM/Sigmas*SigthM';

A3=[0 ones(1,n-1);
       repmat([1 zeros(1,n-1)],n-1,1)];
A=A3;
[vvec,fval1,flag1,output1] = fsolve(@vbarfun2,reshape(rand(n),n^2,1));

cv=condvarfun(V);
cvSC(nu)=cv(1);
cvSP(nu)=cv(2);

%% 2 markets, parameters
n=3
A3=[0 ones(1,n-1);
       repmat([1 zeros(1,n-1)],n-1,1)];
% A3=cirgen(n,2);
% A3(1,3)=0;
% A3(3,1)=0
A=A3;

np=4;
nc=1;

Nvec=[nc repmat(np,1,n-1)]';
NINJ=Nvec*Nvec';
SigmaS=NINJ.*ro.*sigth;
SigmaS=SigmaS-diag(diag(SigmaS));
SigmaS=SigmaS+diag(Nvec.*(sigth+sige+(Nvec-1).*ro.*sigth));
N=length(Nvec);
M=sum(A)';



%% centralized (Vives)
% 
 bet=betp.*sum(Nvec);
%bet=betp; 
sig=sige./sigth;
Sigmas=diag((sigth+sige).*ones(sum(Nvec),1)); % Sigma matrix
Sigmas(Sigmas==0)=ro.*sigth;

zcent2(nu)=2.*ro.*sige./(sigth+sige+ro.^2.*sigth-2.*ro.*sigth+sum(Nvec).*sigth.*(ro-ro.^2));

 zcent(nu)=2.*ro.*sig./((1-ro).*(1+ro*(sum(Nvec)-1))+sig);
 %tcent(nu)=-bet./(sum(Nvec).*(zcent(nu)-1)+2-zcent(nu));
 tcent(nu)=-bet./((sum(Nvec)-1).*(zcent(nu)-1)+1);
 %tcent(nu)=1./(sum(Nvec).*(zcent(nu)-1)+2-zcent(nu))
 MV=sum(Nvec).*ro.*sig./((1-ro).*(sig+(1+(sum(Nvec)-1).*ro)));
cV(nu)=-bet*(sum(Nvec)-MV)/(sum(Nvec)*(sum(Nvec)-MV-2));
zV(nu)=2.*MV/(MV+sum(Nvec));
detV(nu)=(sum(Nvec)-MV-2);
 
 
 ccent(nu)=bet.*(1-zcent(nu))/((sum(Nvec)-1)*(zcent(nu)-1)+1);
 baspcent2(nu)=-1./((sum(Nvec)-1)*ccent(nu)+bet);
 baspcent(nu)=1./tcent(nu);
 %baspcent2(nu)=-1./((sum(Nvec)-1)*ccent(nu)+betp.*sum(Nvec)./2);

 viiV=(1-ro)/(1+sig-ro)*(1+(ro*sig)/((1-ro)*(1+sig+(sum(Nvec)-1)*ro)));
vijV=(1-ro)/(1+sig-ro)*((ro*sig)/((1-ro)*(1+sig+(sum(Nvec)-1)*ro)));

e1=[viiV repmat(vijV,1,sum(Nvec)-1)];
e2=[vijV viiV repmat(vijV,1,sum(Nvec)-2)];
esum=(viiV+(sum(Nvec)-1).*vijV).*ones(1,sum(Nvec));
varesum(nu)=esum*Sigmas*esum';
varei(nu)=e1*Sigmas*e1';
coveiej(nu)=e1*Sigmas*e2';
 
 
coefV(nu)=(MV+sum(Nvec))./(2.*(MV+1)*sum(Nvec));
pvarpartV(nu)=bet/2.*coefV(nu).^2.*(sum(Nvec).*varei(nu)+sum(Nvec).*(sum(Nvec)-1).*coveiej(nu));
pvarnetV(nu)=-bet/2.*coefV(nu).^2.*(sum(Nvec).*varei(nu)+sum(Nvec).*(sum(Nvec)-1).*coveiej(nu));

sumqpV(nu)=-bet.*coefV(nu).^2.*(sum(Nvec).*varei(nu)+sum(Nvec).*(sum(Nvec)-1).*coveiej(nu));
covpartV2(nu)=-(cV(nu).*(sum(Nvec)-1)+bet).*sum(Nvec).*(sum(Nvec)-1).*((1-coefV(nu))/(sum(Nvec)-1)*varei(nu)-coefV(nu).*coveiej(nu));
covnetV2(nu)=covpartV2(nu)-sumqpV(nu);
covnetV(nu)=-(cV(nu).*(sum(Nvec)-1)+bet).*sum(Nvec).*(((1-coefV(nu)).^2+(sum(Nvec)-1).*coefV(nu).^2).*varei(nu)-(2.*(sum(Nvec)-1).*coefV(nu).*(1-coefV(nu))-(sum(Nvec)-1).*(sum(Nvec)-2).*coefV(nu).^2).*coveiej(nu));
volumV(nu)=abs(cV(nu).*(sum(Nvec)-1)+bet).*sqrt((((1-coefV(nu)).^2+(sum(Nvec)-1).*coefV(nu).^2).*varei(nu)-(2.*(sum(Nvec)-1).*coefV(nu).*(1-coefV(nu))-(sum(Nvec)-1).*(sum(Nvec)-2).*coefV(nu).^2).*coveiej(nu)));

totwelfV(nu)=pvarpartV(nu)+covpartV2(nu);
totwelfV2(nu)=pvarnetV(nu)+covnetV(nu);
 % 
%  %% completely segmented centralized markets 
%  bet=betp.*sum(Nvec)/2;
%  %bet=betp;
%  zcentP2(nu)=2.*ro.*sige./(sigth+sige+ro.^2.*sigth-2.*ro.*sigth+sum(Nvec)/2*sigth.*ro.*(1-ro));
% %zcentP(nu)=2.*ro.*sig./((1-ro).*(1+ro*(np-1))+sig);
%  %tcentP(nu)=-bet./(np.*(zcent(nu)-1)+2-zcent(nu));
% zcentP(nu)=2.*ro.*sig./((1-ro).*(1+ro*(sum(Nvec)/2-1))+sig);
%  %tcentP(nu)=-bet./(sum(Nvec)/2.*(zcentP(nu)-1)+2-zcentP(nu));
% tcentP(nu)=-bet./((sum(Nvec)/2-1).*(zcentP(nu)-1)+1);
% 
%  
% ccentP(nu)=bet.*(1-zcentP(nu))/((sum(Nvec)/2-1)*(zcentP(nu)-1)+1);
% baspcentP(nu)=1./tcentP(nu); 
% baspcentP2(nu)=-1/((sum(Nvec)/2 -1)*ccentP(nu)+bet);
%% 2 markets 

%options = optimoptions(@fminunc,'Algorithm','quasi-newton','MaxFunEvals',100000,'MaxIter',1000000,'FinDiffType','central','TolX',1e-8,'TolFun',1e-8);
%options = optimoptions(@fsolve,'MaxFunEvals',10000,'MaxIter',1000000,'FinDiffType','central','TolX',1e-8,'TolFun',1e-8,'Display','iter');
bet=betp.*sum(Nvec)./(n-1)
 if nu==1
     %start=[[zcent(nu);zcent(nu);vii-ypM;vi1;vij;v1j;v11-ycM;v1j;ypM;ycM]];
    start=rand(sum(M)+N^2+N,1);
    % start=start1;
 else
    % start=rand(size(start1));
    start=x2;
     %start=rand(size(start1));
 end
  
  
[x2,fval1,flag2(nu),output1] = fsolve(@vbarfunN3,start);
z=x2(1:sum(M));
v=x2(sum(M)+1:sum(M)+N^2);
vp=x2(sum(M)+N^2+1:end);
Y2=diag(vp); %diagonal matrix with weights on own signal
V2=reshape(v,N,N); %row i corresponds to expectations of agent i
Z2=refillZN(z);  %row i corresponds to prices of agent i
cv2=condvarN2(x2);
cv2C(nu)=minvar(1,1)./cv2(1);
cv2P(nu)=minvar(1,1)./cv2(2);
  
  % 
y2C(nu)=vp(1)+V2(1,1);
v2C2(nu)=V2(1,2);
v2C3(nu)=V2(1,3);

  zpn(nu)=Z2(2,1);
 zcn(nu)=Z2(1,2);
 zp=zpn(nu);
 zc=zcn(nu);
% %zvec(:,nu)=[zcent;zp;zc];
% 
% 
% %num=nc*(zc*(zp-2)-zp+2)+np*(zc*(zp-1)-2*zp+2)+(2*zp-zc*(zp-2)-4);
%
num=(nc+np-1).*zc.*zp+(2-nc-2*np).*zp+(2-np-2*nc).*zc+2*(nc+np)-4;

cp(nu)=bet.*(2-zc)*(zp-1)/num;
 cc(nu)=bet.*(2-zp)*(zc-1)/num;
 ccc=-bet.*zc*(2-zp)/num;
tp(nu)=bet./(-(zc-zp).*nc./(2-zc)+(1-zp).*(nc+np-1)-1);
tp2(nu)=bet.*(2-zc)./num;
%tp(nu)=-1./(-(zc-zp).*nc./(2-zc)+(1-zp).*(nc+np-1)-1);
checkcc(nu)=cc(nu)+((nc-1)*cc(nu)+np*cp(nu)+bet)*(zc-1);
tc(nu)=bet.*(2-zp)./num;

baspc(nu)=-1./((nc-1)*cc(nu)+np*cp(nu)+bet);
 baspp2(nu)=-1./((np-1)*cp(nu)+nc*cc(nu)+bet);
 baspp(nu)=1./tp(nu);
 nuvec(nu)=ro;
tpM=[tc(nu) repmat(tp(nu),1,n-1)]
 %% profits and welfare

NJ=Nvec;
W=[];
for i=1:N
    NI=Nvec(i);
    %coefficients of agent i with respect to J
zIJ=Z2(i,:)'; 
zJI=Z2(:,i);
coefpnum=zJI-2;

coefpden=(NJ+NI-1).*zIJ.*zJI-2.*(NI-1).*zIJ-2.*(NJ-1).*zJI-4;
wI=coefpnum./coefpden;
W=[W; wI'];
end
W=W.*A;
for i=1:N
SigmasS=blkdiag(0,SigmaS);
 
NI=Nvec(i);
% VPW=zeros(N,N);
% VPW(i,:)=VP(i,i)*W(i,:);
wI=W(i,:)';
vIp=Y2(i,:);
vI=V2(i,:);
%vI
%wI*(vIp+NI*vI)

pvec(:,:,i)=wI*(vIp+NI*vI)+diag(W(:,i))*(Y2+diag(Nvec)*V2); %each row corresponds to a price
evec(i,:)=[vIp(i) vI]; 
covSsi=Nvec*ro*sigth;
covSsi(i)=sigth+sige+(NI-1)*ro*sigth;
SigmasS(1,:)=[sigth+sige covSsi'];
    SigmasS(:,1)=[sigth+sige; covSsi]';
for j=1:N 
 expprof(i,j)=A(i,j)*(tpM(i)>0)*tpM(i)*(evec(i,:)-[0 pvec(j,:,i)])*SigmasS*(evec(i,:)-[0 pvec(j,:,i)])';
 exput(i,j)=-bet/2.*A(i,j)*pvec(j,:,i)*SigmaS*pvec(j,:,i)';

 
end
end

profmat(:,nu)=sum(expprof,2);
covnetM2(nu)=profmat(1,nu); 
covnetP2(nu)=profmat(2,nu);
pvarnet2(nu)=(min(tpM)>0).*sum(sum(exput))/2;
totwelf2(nu)=Nvec'*[covnetM2(nu);repmat(covnetP2(nu),N-1,1)]+pvarnet2(nu);
 
 
 
 
%% 4 markets
n=5
A3=[0 ones(1,n-1);
       repmat([1 zeros(1,n-1)],n-1,1)];

A=A3;
 %A=[0 1;
  %  1 0;] %centralized market
%%
np=2;
nc=1;

Nvec=[nc np np np np]';
NINJ=Nvec*Nvec';
SigmaS=NINJ.*ro.*sigth;
SigmaS=SigmaS-diag(diag(SigmaS));
SigmaS=SigmaS+diag(Nvec.*(sigth+sige+(Nvec-1).*ro.*sigth));
N=length(Nvec);
M=sum(A)';

 if nu==1
     %start=[[zcent(nu);zcent(nu);vii-ypM;vi1;vij;v1j;v11-ycM;v1j;ypM;ycM]];
    start=rand(sum(M)+N^2+N,1);
    % start=start1;
 else
    % start=rand(size(start1));
    start=x4;
     %start=rand(size(start1));
 end
  
  
[x4,fval1,flag2(nu),output1] = fsolve(@vbarfunN3,start);
z=x4(1:sum(M));
v=x4(sum(M)+1:sum(M)+N^2);
vp=x4(sum(M)+N^2+1:end);
Y4=diag(vp); %diagonal matrix with weights on own signal
V4=reshape(v,N,N); %row i corresponds to expectations of agent i
Z4=refillZN(z);  %row i corresponds to prices of agent i
zc=Z4(1,2);
zp=Z4(2,1);
cv4=condvarN2(x4);
cv4C(nu)=minvar(1,1)/cv4(1);
cv4P(nu)=minvar(1,1)/cv4(2);


% 

y4C(nu)=vp(1)+V4(1,1);
v4C2(nu)=V4(1,2);
v4C3(nu)=V4(1,3);


zpn4(nu)=zp;
 zcn4(nu)=zc;
% %zvec(:,nu)=[zcent;zp;zc];
% 
% 
% %num=nc*(zc*(zp-2)-zp+2)+np*(zc*(zp-1)-2*zp+2)+(2*zp-zc*(zp-2)-4);
%
num=(nc+np-1).*zc.*zp+(2-nc-2*np).*zp+(2-np-2*nc).*zc+2*(nc+np)-4;

cp4(nu)=bet.*(2-zc)*(zp-1)/num;
 cc4(nu)=bet.*(2-zp)*(zc-1)/num;
 ccc=-bet.*zc*(2-zp)/num;
tp4(nu)=bet./(-(zc-zp).*nc./(2-zc)+(1-zp).*(nc+np-1)-1);
tp4b(nu)=bet.*(2-zc)./num;
%tp(nu)=-1./(-(zc-zp).*nc./(2-zc)+(1-zp).*(nc+np-1)-1);
checkcc(nu)=cc4(nu)+((nc-1)*cc4(nu)+np*cp4(nu)+bet)*(zc-1);
tc4(nu)=bet.*(2-zp)./num;
 baspc4(nu)=-1./((nc-1)*cc4(nu)+np*cp4(nu)+bet);
 baspp4(nu)=-1./((np-1)*cp4(nu)+nc*cc4(nu)+bet);
 baspp4b(nu)=1./tp4(nu);
 %nuvec(nu)=nc;
nuvec(nu)=ro;

 %% profits and welfare, 4 markets
tpM4=[tc4(nu) repmat(tp4(nu),1,n-1)]
NJ=Nvec;
W4=[];
for i=1:N
    NI=Nvec(i);
    %coefficients of agent i with respect to J
zIJ=Z4(i,:)'; 
zJI=Z4(:,i);
coefpnum=zJI-2;

coefpden=(NJ+NI-1).*zIJ.*zJI-2.*(NI-1).*zIJ-2.*(NJ-1).*zJI-4;
wI=coefpnum./coefpden;
W4=[W4; wI'];
end
W4=W4.*A;
for i=1:N
SigmasS=blkdiag(0,SigmaS);
 
NI=Nvec(i);
% VPW=zeros(N,N);
% VPW(i,:)=VP(i,i)*W(i,:);
wI=W4(i,:)';
vIp=Y4(i,:);
vI=V4(i,:);
%vI
%wI*(vIp+NI*vI)

pvec4(:,:,i)=wI*(vIp+NI*vI)+diag(W4(:,i))*(Y4+diag(Nvec)*V4); %each row corresponds to a price
evec4(i,:)=[vIp(i) vI]; 
covSsi=Nvec*ro*sigth;
covSsi(i)=sigth+sige+(NI-1)*ro*sigth;
SigmasS(1,:)=[sigth+sige covSsi'];
    SigmasS(:,1)=[sigth+sige; covSsi]';
for j=1:N 
 expprof4(i,j)=A(i,j)*(tpM4(i)>0)*tpM4(i)*(evec4(i,:)-[0 pvec4(j,:,i)])*SigmasS*(evec4(i,:)-[0 pvec4(j,:,i)])';
 exput4(i,j)=-bet/2.*A(i,j)*pvec4(j,:,i)*SigmaS*pvec4(j,:,i)';

 
end
end

profmat4(:,nu)=sum(expprof4,2);
covnetM4(nu)=profmat4(1,nu); 
covnetP4(nu)=profmat4(2,nu);
pvarnet4(nu)=(min(tpM4)>0).*sum(sum(exput4))/2;
totwelf4(nu)=Nvec'*[covnetM4(nu);repmat(covnetP4(nu),N-1,1)]+pvarnet4(nu);



% 
% 
end
% 
%% 
% scrsz = get(0,'ScreenSize');
% figure('OuterPosition',[1 1 scrsz(3)/2 scrsz(4)/3])
totwelfV(baspcent<0)=nan;
covnetV(baspcent<0)=nan;

baspcent(baspcent<0)=nan;
totwelf2(baspc<0)=nan;
totwelf2(baspp<0)=nan;
covnetM2(baspc<0)=nan;
covnetP2(baspc<0)=nan;
pvarnet2(baspc<0)=nan;
pvarnet2(baspc<0)=nan;
totwelf4(baspc4<=0)=nan;
totwelf4(baspp4<=0)=nan;
covnetM4(baspc4<=0)=nan;
covnetP4(baspc4<=0)=nan;
covnetM4(baspp4<=0)=nan;
covnetP4(baspp4<=0)=nan;
pvarnet4(baspc4<0)=nan;
pvarnet4(baspc4<0)=nan;

baspc(baspc<=0)=nan;
baspp(baspp<=0)=nan;
baspc4(baspc4<=0)=nan;
baspp4(baspp4<=0)=nan;

%% figure for paper
figure


% hold on
subplot(1,3,1)

 plot(nuvec,1./tstarp,'k-.','LineWidth',2.5)
 hold on
 plot(nuvec, baspp4,'g:','LineWidth',2)
 plot(nuvec,baspp,'r:','LineWidth',1.5)
 plot(nuvec,baspcent,'b','LineWidth',1)
 %plot(nuvec,cc,nuvec,cp,nuvec,ccent,'LineWidth',2)
 legend('8 venues (star)','4 venues','2 venues','1 venue (centralized)','Location','NorthWest')
 xlabel('correlation across values,\rho')
 ylabel('price impact')
 title('Average illiquidity, periphery','FontSize',14)

 subplot(1,3,2)
 plot(nuvec,1./tstarc,'k-.','LineWidth',2.5)
 hold on
 plot(nuvec, baspc4,'g:','LineWidth',2)
 plot(nuvec,baspc,'r:','LineWidth',1.5)
 plot(nuvec,baspcent,'b','LineWidth',1)
 %plot(nuvec,cc,nuvec,cp,nuvec,ccent,'LineWidth',2)
 legend('8 venues (star)','4 venues','2 venues','1 venue (centralized)','Location','NorthWest')
 xlabel('correlation across values,\rho')
 ylabel('price impact')
 title('Average illiquidity, center','FontSize',14)
axis([0 1 0 100])

%  
% %  subplot(2,2,3)
% %  plot(nuvec,cv2C,nuvec,cvSC, nuvec,cvSC,nuvec,cv4C, 'LineWidth',2)
% %  legend('2 markets','centralized','8 markets','4 markets','Location','NorthWest')
% %  xlabel('\rho')
% %  ylabel('normalized precision of posterior')
% %  title('Learning, center','FontSize',14)
% % hold on
% 
% %%
% figure

subplot(1,3,3)
 plot(nuvec,cvSP,'k-.','LineWidth',2.5)
 hold on
 plot(nuvec,cv4P,'g:','LineWidth',2)
 plot(nuvec,cv2P,'r:','LineWidth',1.5)
 plot(nuvec,cvSC,'b','LineWidth',1)
 %plot(nuvec,cc,nuvec,cp,nuvec,ccent,'LineWidth',2)
 legend('8 venues (star)','4 venues','2 venues','1 venue (centralized)','Location','NorthWest')
 xlabel('correlation across values,\rho')
 axis([0 1 0.97 1.02])
 %plot(nuvec,cc,nuvec,cp,nuvec,ccent,'LineWidth',2)
 %legend('2 markets','centralized','8 markets','4 markets','Location','NorthWest')
 %xlabel('\rho')
 ylabel('normalized precision of posterior')
 title('Learning, periphery','FontSize',14)
 
%% figure for appendix
figure

 subplot(1,3,1)
 plot(nuvec,covnetSM,'k-.','LineWidth',2.5)
 hold on
 plot(nuvec, covnetM4,'g:','LineWidth',2)
 plot(nuvec,covnetM2,'r:','LineWidth',1.5)
 plot(nuvec,covnetV,'b','LineWidth',1)
 %plot(nuvec,cc,nuvec,cp,nuvec,ccent,'LineWidth',2)
 legend('8 venues (star)','4 venues','2 venues','1 venue (centralized)','Location','NorthWest')
 xlabel('correlation across values,\rho')
 ylabel('expected profit')
 title('Expected profit, center','FontSize',14)
 

% hold on
subplot(1,3,2)
 plot(nuvec,covnetSP,'k-.','LineWidth',2.5)
 hold on
 plot(nuvec, covnetP4,'g:','LineWidth',2)
 plot(nuvec,covnetP2,'r:','LineWidth',1.5)
 plot(nuvec,covnetV,'b','LineWidth',1)
 %plot(nuvec,cc,nuvec,cp,nuvec,ccent,'LineWidth',2)
 legend('8 venues (star)','4 venues','2 venues','1 venue (centralized)','Location','NorthWest')
 xlabel('correlation across values,\rho')
 ylabel('expected profit')
 title('Expected profit, periphery','FontSize',14)


 subplot(1,3,3)
 plot(nuvec,totwelfS,'k-.','LineWidth',2.5)
 hold on
 plot(nuvec,  totwelf4,'g:','LineWidth',2)
 plot(nuvec,totwelf2,'r:','LineWidth',1.5)
 plot(nuvec,totwelfV,'b','LineWidth',1)
 %plot(nuvec,cc,nuvec,cp,nuvec,ccent,'LineWidth',2)
 legend('8 venues (star)','4 venues','2 venues','1 venue (centralized)','Location','NorthWest')
 xlabel('correlation across values,\rho')
  ylabel('total welfare')
 title('Total welfare','FontSize',14)
 
 subplot(1,3,3)
 plot(nuvec,totwelfS,'k-.','LineWidth',2.5)
 hold on
 plot(nuvec,  totwelf4,'g:','LineWidth',2)
 plot(nuvec,totwelf2,'r:','LineWidth',1.5)
 plot(nuvec,totwelfV,'b','LineWidth',1)
 %plot(nuvec,cc,nuvec,cp,nuvec,ccent,'LineWidth',2)
 legend('8 venues (star)','4 venues','2 venues','1 venue (centralized)','Location','NorthWest')
 xlabel('correlation across values,\rho')
  ylabel('total welfare')
 title('Total welfare','FontSize',14)

%  subplot(2,2,4)
% plot(nuvec,pvarnet2,nuvec,pvarnetV,nuvec,pvarnetS,nuvec, pvarnet4,'LineWidth',2)
%  %plot(nuvec,cc,nuvec,cp,nuvec,ccent,'LineWidth',2)
%  legend('2 markets','centralized','8 markets','4 markets','Location','NorthWest')
%  xlabel('\rho')
%  ylabel('consumers\prime utility')
%  title('consumers\prime utility','FontSize',14)
%  

%export_fig D:/Dropbox/ana-peter/simulationfigures/segmentation.eps -transparent